<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item label="院区" prop="wardId">
        <el-select v-model="queryParams.wardId" filterable clearable style="width: 240px">
          <el-option label="全部" value=""></el-option>
          <el-option
            v-for="item in wardIdList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="科室" prop="deptId">
        <TreeDept
          v-model="queryParams.deptId"
          clearable
          style="width: 240px"
          :options="deptList"
          :autoFetch="false"
          :props="{ emitPath: true }"
        />
      </el-form-item>
      <el-form-item label="账号名称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入账号名称"
          clearable
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">
          搜索
        </el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd">
          新增账号
        </el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="pageList" border>
      <el-table-column
        align="center"
        label="序号"
        type="index"
        :index="(index) => (queryParams.pageNum - 1) * queryParams.pageSize + index + 1"
        width="120"
      />
      <el-table-column
        align="center"
        label="所属院区"
        prop="wardName"
        :show-overflow-tooltip="true"
      />
      <el-table-column align="center" label="账号ID" prop="id" :show-overflow-tooltip="true" />
      <el-table-column
        align="center"
        label="用户姓名"
        prop="nickName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="账号名称"
        prop="userName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="使用科室"
        prop="deptName"
        :show-overflow-tooltip="true"
      >
        <template slot-scope="scope">
          {{ scope.row.deptNames && scope.row.deptNames.join("、") }}
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        label="创建时间"
        prop="createTime"
        :show-overflow-tooltip="true"
      />
      <el-table-column align="center" label="状态" prop="status" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          {{ ACCOUNT_STATUS.getLabelByValue(scope.row.status) }}
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        label="操作"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button size="mini" type="text" @click="handleSwitchEnable(scope.row)">
            {{ scope.row.status === ACCOUNT_STATUS.getValueByName('enabled') ? "停用" : "启用" }}
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleEdit(scope.row)"
            :disabled="scope.row.status === ACCOUNT_STATUS.getValueByName('enabled')"
          >
            编辑
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleDelete(scope.row)"
            :disabled="scope.row.status === ACCOUNT_STATUS.getValueByName('enabled')"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <CrudPopup ref="crud" />
  </div>
</template>

<script>
import ApiButton from "@/components/ApiButton/index.vue";
import TreeDept from "@/components/TreeDept";
import {
  accountPageList,
  delAccount,
  enableAccount,
  disableAccount,
  getAllHospital,
  getTreeHospDept
} from "@/api/admin";
import CrudPopup from "./components/CrudPopup/index.vue";
import { ACCOUNT_STATUS } from '@/enums/index'

export default {
  name: "AccountManage",
  components: {
    ApiButton,
    CrudPopup,
    TreeDept
  },
  data() {
    return {
      ACCOUNT_STATUS,
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: "",
        wardId: "", // 院区ID
        deptId: [],
        deptList: [] // 科室数据
      },
      pageList: [],
      wardIdList: [], // 院区列表
      deptList: [] // 科室数据
    };
  },
  created() {
    this.loadData();
  },
  activated() {
    this.loadData();
  },
  watch: {
    "queryParams.wardId"(val) {
      const wardId = val;
      if (wardId) {
        this.queryParams.deptId = [];
        this.getDeptList(wardId);
        this.getList(wardId);
      } else {
        this.queryParams.deptId = [];
        this.pageList = [];
        this.getDeptList();
        this.getList();
      }
    },
    "queryParams.deptIds"(val) {
      const deptId = val[1] || val[0];
      if (deptId) {
        this.getList(deptId);
      } else {
        this.pageList = [];
      }
    },
  },
  methods: {
    loadData() {
      this.loadWardIdList();
      this.getDeptList();
      this.getList();
    },
    /*获取院区列表*/
    async loadWardIdList() {
      const res = await getAllHospital();
      this.wardIdList = res.data;
    },
    /*获取科室数据*/
    async getDeptList(wardId) {
      const res = await getTreeHospDept({ wardId : wardId });
      this.deptList = res.data || [];
    },
    /** 查询角色列表 */
    getList() {
      this.loading = true;
      const params = JSON.parse(JSON.stringify(this.queryParams))
      params.deptId = params.deptId?.length === 2 ? params.deptId.slice(-1).toString() : params.deptId?.length === 1 && params.deptId.slice(-1).toString() || '';
      accountPageList(params)
        .then((res) => {
          const { data: { list, page } } = res
          this.pageList = list || [];
          this.total = page?.total || 0;
        })
        .finally(() => {
          this.loading = false;
        });
    },

    // 表单重置
    reset() {
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getDeptList(this.queryParams.wardId);
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增 */
    handleAdd() {
      this.$refs.crud.open().then(this.getList);
    },

    /** 编辑 */
    handleEdit(item) {
      this.$refs.crud.open(item).then(this.getList);
    },

    /** 启用/禁用切换 */
    handleSwitchEnable(item) {
      const isEnable = item.status === this.ACCOUNT_STATUS.getValueByName('enabled');
      const fetch = async () => {
        if (isEnable) {
          await disableAccount(item.id);
        } else {
          await enableAccount(item.id);
        }
        this.$message.success("操作成功");
        this.getList();
      };
      if (isEnable) {
        this.$modal
          .confirm(`是否确认停用？`)
          .then(fetch)
          .catch(() => {});
      } else {
        fetch();
      }
    },
    handleDelete(item) {
      this.$modal
        .confirm("是否确认删除？")
        .then(async () => {
          await delAccount(item.id);
          this.$message.success("操作成功");
          this.getList();
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" scoped></style>
